import './style.css';

const IS_SUCCESS = 'is-success';
const IS_ERROR = 'is-error';
const DELAY = 1000;
const CODE = import.meta.env.VITE_KEYPAD_CODE || generateCode(4);
let builder = '';

const display = document.getElementById('display') as HTMLDivElement;
const light = document.getElementById('light') as HTMLDivElement;
const keypad = document.getElementById('keypad') as HTMLDivElement;

function generateCode(len: number): string {
  let code = '';
  for (let i = 0; i < len; i++) {
    code += Math.floor(Math.random() * 10).toString();
  }
  return code;
}

function resetCode() {
  builder = '';
  display.innerText = '_'.repeat(CODE.length);
  light.classList.remove(IS_SUCCESS, IS_ERROR);
}

function composeDigit(digit: number) {
  builder += digit.toString();
  display.innerText = builder + '_'.repeat(CODE.length - builder.length);
  light.classList.remove(IS_SUCCESS, IS_ERROR);
  if (CODE.startsWith(builder)) {
    light.classList.add(IS_SUCCESS);
  } else {
    light.classList.add(IS_ERROR);
    setTimeout(resetCode, DELAY);
  }
}

for (let i = 1; i < 11; i++) {
  const digit = i % 10;
  const button = document.createElement('button');
  button.innerText = digit.toString();
  button.onclick = () => composeDigit(digit);
  keypad.appendChild(button);
}
const reset = document.createElement('button');
reset.innerText = 'C';
reset.onclick = resetCode;
keypad.appendChild(reset);
resetCode();
